import java.util.Observable;
import java.util.*;
import java.awt.*;
import javax.swing.*;

public class Model extends Observable
{
   /** The observers that are watching this model for changes. */
  private ArrayList<Observer> observers;
  private ArrayList<Thingy> thingies;
  private Thingy curThingy;
  private Color curColour;
  private int curThiccness;
  public Color menuColour;
  public Color sideColour;
  public Color controlColour;

  // Constructor
  public Model()
  {
    this.observers = new ArrayList();
    this.thingies = new ArrayList();
    setChanged();
  }
  
  public void newThingy(int x, int y)
  {
    curThingy = new Thingy(curColour, curThiccness);
    thingies.add(curThingy);
    curThingy.addPoint(x, y);
  }
  
  public void addPoint(int x, int y)
  {
    curThingy.addPoint(x, y);
  }
  
  public ArrayList<Thingy> getThingies()
  {
    return thingies;
  }
  
  public void setMenuColour(Color c)
  {
    menuColour = c;
    setChanged();
		notifyObservers();
  }
  
  public void setSideColour(Color c)
  {
    sideColour = c;
    setChanged();
		notifyObservers();
  }
  
  public void setControlColour(Color c)
  {
    controlColour = c;
    setChanged();
		notifyObservers();
  }

  // Add observer to be notified on change
  public void addObserver(Observer observer)
  {
    this.observers.add(observer);
  }

  // Remove an observer from opdate list
  public void removeObserver(Observer observer)
  {
    this.observers.remove(observer);
  }

   // Notify all observers shit went down
  public void notifyObservers()
  {
    for (Observer observer: this.observers)
    {
      observer.update(this);
    }
  }
}

class Thingy
{
  private ArrayList<Point> points;
  private Color colour;
  private int thiccness;
  
  public Thingy(Color c, int x)
  {
    points = new ArrayList();
    this.colour = c;
    this.thiccness = x;
  }
  
  public void addPoint(int x, int y)
  {
    points.add(new Point(x, y));
  }
  
  public ArrayList<Point> getPoints()
  {
    return points;
  }
  
  public Color getColour()
  {
    return colour;
  }
  
  public int getThiccness()
  {
    return thiccness;
  }
}
